package cz.cvut.fel;

import kareltherobot.FelKarel;
import kareltherobot.RobotTask;
import kareltherobot.UrRobot;
import kareltherobot.World;

public class Lecture3Task implements RobotTask {

    // y, x, length
    private static int[][] horizontalWalls = new int[][]{
        new int[]{1, 4, 3},
        new int[]{3, 1, 4},
        new int[]{5, 4, 3},
        new int[]{2, 2, 3},
        new int[]{5, 2, 1},
        new int[]{4, 2, 1},
        new int[]{2, 6, 1}
    };
    
    // x, y, length
    private static int[][] verticalWalls = new int[][]{
        new int[]{2, 1, 2},
        new int[]{2, 2, 1},
        new int[]{4, 5, 2},
        new int[]{4, 5, 2},
        new int[]{5, 1, 2},
        new int[]{4, 4, 1},
        new int[]{5, 3, 1}
    };
    
    @Override
    public void task() {
        prepareWorldMaze();
        
        World.placeBeepers(6, 6, 1);

        World.setDelay(5);

        UrRobot karel = new UrRobot(3, 1, North, 0);

        FelKarel felKarel = new Lecture3Karel();
        felKarel.setRobot(karel);
        felKarel.execute();
    }
    
    public static void prepareWorldMaze() {
        World.getWorld("KarelWorld\n"
                + "streets 7\n"
                + "avenues 7\n"
                + "eastwestwalls 6 1 6\n"
                + "northsouthwalls 6 1 7");
    
        for (int[] wall : horizontalWalls) {
            World.placeEWWall(wall[0], wall[1], wall[2]);
        }
        
        for (int[] wall : verticalWalls) {
            World.placeNSWall(wall[0], wall[1], wall[2]);
        }
    }
    
}
