package kareltherobot;

import cz.cvut.fel.Lecture3Task;
import kareltherobot.Directions.Direction;

public abstract class FelKarel {

    private UrRobot robot;
    
    public FelKarel() {}
    
    public FelKarel(UrRobot robot) {
        this.robot = robot;
    }
    
    public abstract void execute();
    
    public void turnLeft() {
        robot.turnLeft();
    }
    
    public void move() {
        robot.move();
    }
    
    public boolean isInFrontOfWall() {
        int street = robot.street();
        int avenue = robot.avenue();
        Direction direction = robot.direction();
        
        switch (direction.points()) {
            case Direction.NorthVal:
                return World.checkEWWall(street, avenue);
            case Direction.SouthVal:
                return World.checkEWWall(street-1, avenue);
            case Direction.EastVal:
                return World.checkNSWall(street, avenue);
            case Direction.WestVal:
                return World.checkNSWall(street, avenue-1);
        }
        return false;
    }
    
    public int getDirection() {
        return robot.direction().points();
    }
    
    public boolean isOnBeeper() {
        int street = robot.street();
        int avenue = robot.avenue();
        
        return World.checkBeeper(street, avenue);
    }
    
    public void putBeeper() {
        robot.putBeeper();
    }
    
    public void pickBeeper() {
        robot.pickBeeper();
    }
    
    public void turnOff() {
        robot.turnOff();
    }

    public UrRobot getRobot() {
        return robot;
    }

    public void setRobot(UrRobot robot) {
        this.robot = robot;
    }
    
    public static void main(String[] args) {
        Lecture3Task task = new Lecture3Task();
        World.setVisible(true);
        task.task();
    }
}
